<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: schema.proto

namespace Stategate;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Entity represents a single record(k/v pairs) with a unique key with a given [type](https://en.wikipedia.org/wiki/Type_system), belonging to a particular [domain](https://en.wikipedia.org/wiki/Domain-driven_design)
 * EventService clients should use the EntityService to persist & interact with the current state of an entity.
 *
 * Generated from protobuf message <code>stategate.Entity</code>
 */
class Entity extends \Google\Protobuf\Internal\Message
{
    /**
     * the entity's business domain(ex: accounting)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string domain = 1 [(.validator.field) = {</code>
     */
    private $domain = '';
    /**
     * the entity's type (ex: user)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string type = 2 [(.validator.field) = {</code>
     */
    private $type = '';
    /**
     * the entity's key (unique within type).
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string key = 3 [(.validator.field) = {</code>
     */
    private $key = '';
    /**
     * the entity's values (k/v pairs)
     *
     * Generated from protobuf field <code>.google.protobuf.Struct values = 4 [(.validator.field) = {</code>
     */
    private $values = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $domain
     *           the entity's business domain(ex: accounting)
     *           must not be empty or contain spaces
     *     @type string $type
     *           the entity's type (ex: user)
     *           must not be empty or contain spaces
     *     @type string $key
     *           the entity's key (unique within type).
     *           must not be empty or contain spaces
     *     @type \Google\Protobuf\Struct $values
     *           the entity's values (k/v pairs)
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Schema::initOnce();
        parent::__construct($data);
    }

    /**
     * the entity's business domain(ex: accounting)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string domain = 1 [(.validator.field) = {</code>
     * @return string
     */
    public function getDomain()
    {
        return $this->domain;
    }

    /**
     * the entity's business domain(ex: accounting)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string domain = 1 [(.validator.field) = {</code>
     * @param string $var
     * @return $this
     */
    public function setDomain($var)
    {
        GPBUtil::checkString($var, True);
        $this->domain = $var;

        return $this;
    }

    /**
     * the entity's type (ex: user)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string type = 2 [(.validator.field) = {</code>
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * the entity's type (ex: user)
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string type = 2 [(.validator.field) = {</code>
     * @param string $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkString($var, True);
        $this->type = $var;

        return $this;
    }

    /**
     * the entity's key (unique within type).
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string key = 3 [(.validator.field) = {</code>
     * @return string
     */
    public function getKey()
    {
        return $this->key;
    }

    /**
     * the entity's key (unique within type).
     * must not be empty or contain spaces
     *
     * Generated from protobuf field <code>string key = 3 [(.validator.field) = {</code>
     * @param string $var
     * @return $this
     */
    public function setKey($var)
    {
        GPBUtil::checkString($var, True);
        $this->key = $var;

        return $this;
    }

    /**
     * the entity's values (k/v pairs)
     *
     * Generated from protobuf field <code>.google.protobuf.Struct values = 4 [(.validator.field) = {</code>
     * @return \Google\Protobuf\Struct
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * the entity's values (k/v pairs)
     *
     * Generated from protobuf field <code>.google.protobuf.Struct values = 4 [(.validator.field) = {</code>
     * @param \Google\Protobuf\Struct $var
     * @return $this
     */
    public function setValues($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Struct::class);
        $this->values = $var;

        return $this;
    }

}

